<script>
  import { extent } from "d3-array";
  import { select } from "d3-selection";
  import { scaleLinear } from "d3-scale";
  import { brush } from "d3-brush";
  import { axisBottom, axisLeft } from "d3-axis";

  // Properties
  export let data = [];
  export let x = (d) => d.x;
  export let y = (d) => d.y;
  export let xLabel = "x";
  export let yLabel = "y";
  export let localSelectedPoints = [];

  export let globalSelectedPoints = [];


  // Dimensions
  const width = 400;
  const height = 300;
  const margin = { top: 10, right: 10, bottom: 35, left: 45 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Scales
  const xScale = scaleLinear().domain(extent(data, x)).range([0, innerWidth]);
  const yScale = scaleLinear().domain(extent(data, y)).range([innerHeight, 0]);

  // Axes
  const xAxis = (node) => axisBottom(xScale)(select(node));
  const yAxis = (node) => axisLeft(yScale)(select(node));

  // BRUSHING

  let range = null;

  const getRange = ({ selection }) => {
    range = selection;
  };

  const myBrush = brush().on("end", getRange);
 

  let b;
  $: select(b).call(myBrush);

  // COMPUTE COORDINATES
  const coords = [];
  data.forEach((datapoint) => {
    coords.push({ x: xScale(x(datapoint)), y: yScale(y(datapoint)) });
  });

  // SELECT POINTS
 
  if (localSelectedPoints.length == 0) {
    data.forEach((datapoint) => {
      localSelectedPoints.push(true);
    });
  }

  
  const updateLocalSelectedPoints = (newRange) => {
    localSelectedPoints.forEach((element, i) => {
      if (newRange == null) {
        localSelectedPoints[i] = true;
      } else {
        const minX = Math.min(newRange[0][0], newRange[1][0]);
        const maxX = Math.max(newRange[0][0], newRange[1][0]);
        const minY = Math.min(newRange[0][1], newRange[1][1]);
        const maxY = Math.max(newRange[0][1], newRange[1][1]);
        const pointX = coords[i].x;
        const pointY = coords[i].y;
        if (
          pointX >= minX &&
          pointX <= maxX &&
          pointY >= minY &&
          pointY <= maxY
        ) {
          // If the point is within the selected area
          localSelectedPoints[i] = true;
        } else {
          localSelectedPoints[i] = false;
        }
      }
    });
  };

  $: updateLocalSelectedPoints(range);
</script>

<svg viewBox="0 0 {width} {height}" class="mx-2" style="max-width: {width}px">
  <g transform="translate({margin.left},{margin.top})">
    <g bind:this={b}>
      {#each data as d, i}
        <circle
          cx={coords[i].x}
          cy={coords[i].y}
          r={3}
          fill="steelblue"
          fill-opacity="0.5"
          stroke="steelblue"
          stroke-width="1.5"
          stroke-opacity="1"
          class:notSelected={!globalSelectedPoints[i]}
        />
      {/each}
    </g>
    <g use:xAxis transform="translate(0, {innerHeight})">
      <text class="axisLabel" x={innerWidth / 2} y={margin.bottom - 5}
        >{xLabel}</text
      >
    </g>
    <g use:yAxis>
      <text
        class="axisLabel"
        y={-margin.left + 10}
        x={-innerHeight / 2}
        transform="rotate(-90)">{yLabel}</text
      >
    </g>
  </g>
</svg>

<style>
  .axisLabel {
    text-anchor: middle;
    vertical-align: bottom;
    fill: currentcolor;
  }
  circle.notSelected {
    stroke: darkgray;
    fill: darkgray;
    fill-opacity: 0.3;
    stroke-opacity: 0.5;
  }
</style>
